//---------------------------------------------------------------------------

#ifndef ProgramUnitH
#define ProgramUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ScktComp.hpp>
#include <Buttons.hpp>
//---------------------------------------------------------------------------
#include "mod_durak.h"
#include "CSPIN.h"
//---------------------------------------------------------------------------
#define WINDOW_TITLE              "  ''"
#define PROGRAM_TITLE             "  1.0.0.1"
//---------------------------------------------------------------------------
//  
#define MESS_SERVER_CLOSE_GAME    "#closegame"
#define MESS_SERVER_MESSAGE       "#message"
//  
#define MESS_CLIENT_NAME          "#name"
#define MESS_CLIENT_STEP          "#step"
#define MESS_CLIENT_OTBIV         "#otbiv"
#define MESS_CLIENT_NOT_OTBIV     "#nototbiv"
//---------------------------------------------------------------------------
typedef struct
{
  int my_id;
  int size_user;
  int size_user_kart[6];
  int user[6][36];
  int size_table;
  int table[36];
  int size_kolod;
  int kolod[36];
  int size_bito;
  int bito[36];
  char name[6][20];
  int kozer;
  int wstep;
  bool fl_kozer;
} TDurakData;
//---------------------------------------------------------------------------
class TfrmProg : public TForm
{
__published:
        TGroupBox *GroupBox1;
        TListBox *lbConnect;
        TSpeedButton *sbSend;
        TSpeedButton *sbDisconnect;
        TSpeedButton *sbNew;
        TSpeedButton *sbClose;
        TServerSocket *sSock;
        TLabel *Label1;
        TCSpinEdit *csUser;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall sbSendClick(TObject *Sender);
        void __fastcall sbDisconnectClick(TObject *Sender);
        void __fastcall sbNewClick(TObject *Sender);
        void __fastcall sbCloseClick(TObject *Sender);
        void __fastcall sSockClientDisconnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall sSockClientRead(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall sSockClientWrite(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall sSockClientConnect(TObject *Sender,
          TCustomWinSocket *Socket);
private:
  TDurak *obj;
public:
  __fastcall TfrmProg(TComponent* Owner);
  bool active;
  bool fl_all_otbit;
//  
  void __fastcall InitProg(void)
    {
      Caption = WINDOW_TITLE;
      Application->Title = PROGRAM_TITLE;
      active = false;
      //  
      obj = new TDurak();  
    };
  void __fastcall FreeProg(void)
    {
      for (int PrX = 0; PrX < lbConnect->Items->Count; PrX++)
        {
          sSock->Socket->Connections[PrX]->SendText(MESS_SERVER_CLOSE_GAME);
          sSock->Socket->Connections[PrX]->Close();
        }
      delete obj;
    };
//----------------------------------------------------
//  
  void __fastcall StartGame(void)
    { //  
      active = true;
      obj->NewGame();
      obj->SetKartToTable(lbConnect->Items->Count);
      SendAllData();
    };
  void __fastcall CloseGame(void)
    { //  
      active = false;
      for (int PrX = 0; PrX < lbConnect->Items->Count; PrX++)
        {
          sSock->Socket->Connections[PrX]->SendText(MESS_SERVER_CLOSE_GAME);
          sSock->Socket->Connections[PrX]->Close();
        }    
    };
  void __fastcall MessageRead(TCustomWinSocket *sock)
    { //   
      AnsiString rec;
      rec = sock->ReceiveText();
      //  
      if (rec.SubString(1, strlen(MESS_CLIENT_NAME)) == MESS_CLIENT_NAME)
        {
          AddNameUser(rec.SubString(strlen(MESS_CLIENT_NAME) + 1, rec.Length()));
        }
      //  
      if (rec.SubString(1, strlen(MESS_CLIENT_STEP)) == MESS_CLIENT_STEP)
        {
          AnsiString s;
          int index;
          int id;
          for (int PrX = 0; PrX < sSock->Socket->ActiveConnections; PrX++)
            {
              if (sock == sSock->Socket->Connections[PrX])
                {
                  index = PrX;
                  break;
                }
            }
          s = rec;
          s.Delete(1, strlen(MESS_CLIENT_STEP));
          id = StrToInt(s);
          if (obj->SetStep(index, id))
            {
              SendAllData();
            }
        }
      //    
      if (rec.SubString(1, strlen(MESS_CLIENT_OTBIV)) == MESS_CLIENT_OTBIV)
        {
          if (obj->SetNextStepA())
            {
              SendAllData();
            }
        }
      //   
      if (rec.SubString(1, strlen(MESS_CLIENT_NOT_OTBIV)) == MESS_CLIENT_NOT_OTBIV)
        {
          obj->SetZabirau();
          SendAllData();
        }
    };
  void __fastcall MessageWrite(TCustomWinSocket *sock)
    { //   
    };
//----------------------------------------------------
//  
  void __fastcall CopyMem(void *buf_to, void *buf_from, int size)
    {
      char *to;
      char *from;
      to = (char *)buf_to;
      from = (char *)buf_from;
      for (int PrX = 0; PrX < size; PrX++)
        {
          to[PrX] = from[PrX];
        }
    };
  void __fastcall AddNameUser(AnsiString name)
    {
      lbConnect->Items->Add(name);
    };
  void __fastcall SendAllData(void)
    {
      TDurakData *data;
      int PrX, PrY;
      data = new TDurakData();
      //  
      data->kozer = obj->GetKozer();
      //   
      data->fl_kozer = obj->GetParamKozer();
      //   
      data->size_user = obj->GetSizeUsers();
      for (PrX = 0; PrX < obj->GetSizeUsers(); PrX++)
        {
          //   
          data->size_user_kart[PrX] = obj->GetSizeKartForUser(PrX);
          //   
          for (PrY = 0; PrY < obj->GetSizeKartForUser(PrX); PrY++)
            {
              //    
              data->user[PrX][PrY] = obj->GetKart(PrX, PrY);
            }
        }
      //     
      data->size_kolod = obj->GetAllKartForBito();
      for (PrX = 0; PrX < obj->GetAllKartForBito(); PrX++)
        {
          //   
          data->kolod[PrX] = obj->GetKartBito(PrX);
        }
      //     
      data->size_table = obj->GetSizeTableKart();
      for (PrX = 0; PrX < obj->GetSizeTableKart(); PrX++)
        {
          //    
          data->table[PrX] = obj->GetIntexKartForTable(PrX); 
        }
      //     
      data->size_bito = obj->GetSizeBitoB();
      for (PrX = 0; PrX < obj->GetSizeBitoB(); PrX++)
        {
          //    
          data->bito[PrX] = obj->GetKartBitoB(PrX); 
        }
      //  
      for (PrX = 0; PrX < lbConnect->Items->Count; PrX++)
        {
          CopyMem(&data->name[PrX][0], lbConnect->Items->Strings[PrX].c_str(), lbConnect->Items->Strings[PrX].Length());
          data->name[PrX][lbConnect->Items->Strings[PrX].Length()] = 0;
        }
      for (int PrX = 0; PrX < sSock->Socket->ActiveConnections; PrX++)
        {
          //  
          data->my_id = PrX;
          //  
          data->wstep = obj->GetParamwStep(PrX);
          sSock->Socket->Connections[PrX]->SendBuf(data, sizeof(TDurakData));
        }
      delete data;
    };
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmProg *frmProg;
//---------------------------------------------------------------------------
#endif
