//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ProgramUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmProg *frmProg;
//---------------------------------------------------------------------------
void call_back_func(int type_message, AnsiString param)
{
  AnsiString s = param;
  if (frmProg->type_game == TG_NETWORK)
    { //   
      s.Delete(1, 1);
      frmProg->cSock->Socket->SendText(MESS_CLIENT_STEP + s);
      frmProg->SoundPlay(SOUND_KART);
    }
      else
        {
          s.Delete(1, 1);
          if (frmProg->obj_log->SetStep(0, StrToInt(s)))
            {
              frmProg->SoundPlay(SOUND_KART);
              frmProg->LocalDraw();
              frmProg->StepGame();
              frmProg->InfoIfEndGame();
            }
        }
}
//---------------------------------------------------------------------------
void __fastcall TfrmProg::SetFuncGame(void)
{
  frmProg->obj_table->SetCallBackFunc(call_back_func);
}
//---------------------------------------------------------------------------
__fastcall TfrmProg::TfrmProg(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmProg::mmExitClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------
void __fastcall TfrmProg::FormClose(TObject *Sender, TCloseAction &Action)
{
  if (MessageBox(Handle, "     ?", WINDOW_TITLE, MB_YESNO | MB_ICONQUESTION) == 6)
    {
      Action = caFree;
      FreeProg();
    }
      else
        {
          Action = caNone;
        }
}
//---------------------------------------------------------------------------
void __fastcall TfrmProg::FormCreate(TObject *Sender)
{       
  InitProg();        
}
//---------------------------------------------------------------------------
void __fastcall TfrmProg::tmTimerTimer(TObject *Sender)
{
  stBar->Panels->Items[0]->Text = ": " + TimeToStr(Time());
  stBar->Panels->Items[1]->Text = ": " + DateToStr(Date());  
}
//---------------------------------------------------------------------------

void __fastcall TfrmProg::mmNewClick(TObject *Sender)
{
  frmNewGame->ShowModal();
  if (frmNewGame->fl)
    {
      if (frmNewGame->rbNet->Checked)
        {
          NewNetGame();
        }
          else
            {
              NewLocalGame();
            }
    }
}
//---------------------------------------------------------------------------

void __fastcall TfrmProg::cSockError(TObject *Sender,
      TCustomWinSocket *Socket, TErrorEvent ErrorEvent, int &ErrorCode)
{
  if (type_connect == TC_CONNECT)
    { //    
      MessageBox(Handle, "     !\n       IP address  host ", WINDOW_TITLE, MB_OK | MB_ICONINFORMATION);
      CloseNetGame();
    }
  if (type_connect == TC_PROCESS)
    {
      MessageBox(Handle, "   !", WINDOW_TITLE, MB_OK | MB_ICONINFORMATION);
      CloseNetGame();
    }
  ErrorCode = 0;  
}
//---------------------------------------------------------------------------

void __fastcall TfrmProg::cSockDisconnect(TObject *Sender,
      TCustomWinSocket *Socket)
{
  CloseNetGame();        
}
//---------------------------------------------------------------------------

void __fastcall TfrmProg::cSockConnecting(TObject *Sender,
      TCustomWinSocket *Socket)
{
  SetInfo("  ");
}
//---------------------------------------------------------------------------

void __fastcall TfrmProg::cSockConnect(TObject *Sender,
      TCustomWinSocket *Socket)
{
  StartNetGame();          
}
//---------------------------------------------------------------------------

void __fastcall TfrmProg::mmCloseClick(TObject *Sender)
{
  if (type_game == TG_NETWORK)
    {
      CloseNetGame();
    }
      else
        {
          CloseLocalGame();
        }
}
//---------------------------------------------------------------------------

void __fastcall TfrmProg::cSockRead(TObject *Sender,
      TCustomWinSocket *Socket)
{
  ReadMessage(Socket);        
}
//---------------------------------------------------------------------------

void __fastcall TfrmProg::sbOKClick(TObject *Sender)
{ 
  if (type_game == TG_NETWORK)
    {
      if (wstep == TU_OTBIV)
        {
          cSock->Socket->SendText(MESS_CLIENT_NOT_OTBIV);
        }
      if (wstep == TU_STEP || wstep == TU_PODKID)
        {
          cSock->Socket->SendText(MESS_CLIENT_OTBIV);
        }
    }
      else
        {
          if (wstep == TU_OTBIV)
            {
              obj_log->SetZabirau();
              LocalDraw();
              StepGame();
            }
          if (wstep == TU_STEP || wstep == TU_PODKID)
            {
              if (obj_log->SetNextStepA())
                {
                  LocalDraw();
                  StepGame();
                }
            }
        }
}
//---------------------------------------------------------------------------

void __fastcall TfrmProg::N2Click(TObject *Sender)
{
  SetAllOblToComponent();
  SetAllFonToComponent();
  frmOption->cbSKart->ItemIndex = option->sound_k;
  frmOption->cbObl->ItemIndex = option->image;
  frmOption->sbSound->Checked = option->sound;
  frmOption->cbFon->ItemIndex = option->image_f;
  frmOption->path = sys_path + "image\\obl";
  frmOption->path_f = sys_path + "image\\fon";
  frmOption->ind_obl = option->image;
  frmOption->ShowModal();
  if (frmOption->fl)
    {
      option->sound_k = frmOption->cbSKart->ItemIndex;
      option->image = frmOption->cbObl->ItemIndex;
      option->sound = frmOption->sbSound->Checked;
      option->image_f = frmOption->cbFon->ItemIndex;
      SetProgramParam();
      if (active_game)
        {
          obj_table->SetTextureAllKarts();
          obj_table->SetTextureMyKarts();
          obj_table->SetTextureTableKarts();
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TfrmProg::N3Click(TObject *Sender)
{
  frmAbout->ShowModal();        
}
//---------------------------------------------------------------------------



void __fastcall TfrmProg::FormResize(TObject *Sender)
{
  if (Width < 813)
    {
      Width = 813;
    }
  if (Height < 598)
    {
      Height = 598;
    }
  imFon->Left = 0;
  imFon->Top = 0;
  imFon->Width = ClientWidth;
  imFon->Height = ClientHeight - stBar->Height;
  lbInfo->Left = ClientWidth - lbInfo->Width - 10;
  lbInfo->Top = ClientHeight - 60;
  sbOK->Left = lbInfo->Left + lbInfo->Width / 4;
  sbOK->Top = ClientHeight - 80;
  SetParamDrawTable();
}
//---------------------------------------------------------------------------


void __fastcall TfrmProg::mmServerClick(TObject *Sender)
{
  if (FileExists(sys_path + "server.exe"))
    {
      AnsiString path;
      path = '"';
      path = path + sys_path + "server.exe";
      path = path + '"';
      WinExec(path.c_str(), 0);
    }
      else
        {
          MessageBox(Handle, "   !", WINDOW_TITLE, MB_OK | MB_ICONINFORMATION);
        }                
}
//---------------------------------------------------------------------------

