//---------------------------------------------------------------------------

#ifndef ProgramUnitH
#define ProgramUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <ScktComp.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <MPlayer.hpp>
//---------------------------------------------------------------------------
#include "mod_durak.h"
#include "FormNewGame.h"
#include "mod_durak_log.h"
#include "FormOption.h"
#include <stdio.h>
#include "FormAbout.h"
#include <jpeg.hpp>
#include "mus_dll.h"
//---------------------------------------------------------------------------
#define WINDOW_TITLE              " ''"
#define PROGRAM_TITLE             "game v1.0.0.2"
//---------------------------------------------------------------------------
#define SOUND_KART                0
#define SOUND_END_GAME_V          1
#define SOUND_END_GAME_P          2
//---------------------------------------------------------------------------
#define FILE_SOUND_VOSKL          "voskl.wav"
#define FILE_SOUND_DIN            "din.wav"
#define FILE_SOUND_PROIGRAL       "gameower.wav"
#define FILE_SOUND_VIIGRAL        "okgame.wav"
//---------------------------------------------------------------------------
#define TC_CONNECT                0
#define TC_PROCESS                1
//---------------------------------------------------------------------------
#define TG_NETWORK                0
#define TG_LOCAL                  1
//---------------------------------------------------------------------------
//  
#define MESS_SERVER_CLOSE_GAME    "#closegame"
#define MESS_SERVER_MESSAGE       "#message"
//  
#define MESS_CLIENT_NAME          "#name"
#define MESS_CLIENT_STEP          "#step"
#define MESS_CLIENT_OTBIV         "#otbiv"
#define MESS_CLIENT_NOT_OTBIV     "#nototbiv"
//---------------------------------------------------------------------------
#define FILE_PARAM                "option.opt"
//---------------------------------------------------------------------------
#define TU_NONE                   0
#define TU_STEP                   1
#define TU_OTBIV                  2
#define TU_PODKID                 3
//---------------------------------------------------------------------------
#define NAME_DLL_MUSIC            "mus.dll"
//---------------------------------------------------------------------------
typedef struct
{
  int my_id;
  int size_user;
  int size_user_kart[6];
  int user[6][36];
  int size_table;
  int table[36];
  int size_kolod;
  int kolod[36];
  int size_bito;
  int bito[36];
  char name[6][20];
  int kozer;
  int wstep;
  bool fl_kozer;
} TDurakData;
//---------------------------------------------------------------------------
typedef struct
{
  int sound_k;
  int image;
  bool sound;
  int image_f;
} TProgramOption;
//---------------------------------------------------------------------------
class TfrmProg : public TForm
{
__published:
        TClientSocket *cSock;
        TMainMenu *mmMenu;
        TMenuItem *N1;
        TMenuItem *mmNew;
        TMenuItem *mmClose;
        TMenuItem *mmExit;
        TStatusBar *stBar;
        TTimer *tmTimer;
        TLabel *lbInfo;
        TSpeedButton *sbOK;
        TMenuItem *N2;
        TMediaPlayer *sound;
        TMenuItem *N3;
        TMenuItem *N4;
        TImage *imFon;
        TMenuItem *mmServer;
        void __fastcall mmExitClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall tmTimerTimer(TObject *Sender);
        void __fastcall mmNewClick(TObject *Sender);
        void __fastcall cSockError(TObject *Sender,
          TCustomWinSocket *Socket, TErrorEvent ErrorEvent,
          int &ErrorCode);
        void __fastcall cSockDisconnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall cSockConnecting(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall cSockConnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall mmCloseClick(TObject *Sender);
        void __fastcall cSockRead(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall sbOKClick(TObject *Sender);
        void __fastcall N2Click(TObject *Sender);
        void __fastcall N3Click(TObject *Sender);
        void __fastcall FormResize(TObject *Sender);
        void __fastcall mmServerClick(TObject *Sender);
private:
  int type_connect;
  AnsiString names[2];
  int size_kart_user[2];
  int kart_user[2][36];
  int size_kart_table;
  int kart_table[12];
//  
  TProgramOption *option;
  bool active_game;
  TMusicDLL *mus_dll;
public:
  __fastcall TfrmProg(TComponent* Owner);
  AnsiString sys_path; //  
  TDurakTable *obj_table; //    
  TDurak *obj_log; //    
  int type_game;
  int wstep;
//   
  void __fastcall InitProg(void)
    { //   
      Caption = WINDOW_TITLE;
      Application->Title = PROGRAM_TITLE;
      int PrX, PrY;
      for (PrX = 1; PrX <= Application->ExeName.Length(); PrX++)
        {
          if (Application->ExeName[PrX] == '\\')
            {
              PrY = PrX;
            }
        }
      sys_path = Application->ExeName.SubString(1, PrY);
      //  
      obj_table = new TDurakTable(this, sys_path + "image\\", sys_path + "image\\obl0.jpg", Handle);
      option = NULL;
      option = LoadFileParam(sys_path + FILE_PARAM);
      if (!option)
        {
          option = new TProgramOption();
          option->sound_k = 0;
          option->image = 0;
          option->sound = true;
          option->image_f = 0;
        }
      SetProgramParam();
      obj_log = new TDurak();
      SetActiveBtn(false);
      SetFuncGame();
      active_game = false;
      mus_dll = new TMusicDLL();
      if (mus_dll->LoadDLL(sys_path + NAME_DLL_MUSIC))
        {
          if (mus_dll->LoadFunc())
            {
//              mmMusic->Enabled = true;
            }
              else
                {
                  delete mus_dll;
                  mus_dll = NULL;
//                  mmMusic->Enabled = false;
                }
        }
          else
            {
              delete mus_dll;
              mus_dll = NULL;
//              mmMusic->Enabled = false;
            }
    };
  void __fastcall FreeProg(void)
    { //    
      active_game = false;
      SaveFileParam(sys_path + FILE_PARAM, option);
      delete obj_table;
      delete obj_log;
      delete option;
      if (mus_dll)
        {
          mus_dll->free();
          delete mus_dll;
        }
    };
//----------------------------------------------------
//  
  void __fastcall NewNetGame(void)
    {
      type_game = TG_NETWORK;
      bool fl_ip;
      AnsiString dig;
      dig = "0123456789";
      fl_ip = false;
      for (int PrX = 1; PrX <= 10; PrX++)
        {
          if (frmNewGame->edIP->Text[1] == dig[PrX])
            {
              fl_ip = true;
              break;
            }
        }
      if (fl_ip)
        {
          cSock->Address = frmNewGame->edIP->Text;
        }
          else
            {
              cSock->Host = frmNewGame->edIP->Text;
            }
      type_connect = TC_CONNECT;
      cSock->Active = true;
      obj_table->FreeObj();
      SetActiveBtn(true);
    };
  void __fastcall CloseNetGame(void)
    {
      cSock->Active = false;
      SetActiveBtn(false);
      sbOK->Visible = false;
      SetInfo("");
      obj_table->FreeObj();
    };
  void __fastcall StartNetGame(void)
    {
      type_connect = TC_PROCESS;
      SetInfo("");
      cSock->Socket->SendText(MESS_CLIENT_NAME + frmNewGame->edName->Text);
      obj_table->CreateObj();
    };
  void __fastcall ReadMessage(TCustomWinSocket *sock)
    {
      int len;
      void *buffer;
      int read;
      len = sock->ReceiveLength();
      buffer = new char[len];
      read = sock->ReceiveBuf(buffer, len);
      if (read != len)
        {
          MessageBox(Handle, " :   !", WINDOW_TITLE, MB_OK | MB_ICONINFORMATION);
          return;
        }
      AnsiString str;
      str = (char *)buffer;
      if (str.SubString(1, strlen(MESS_SERVER_MESSAGE)) == MESS_SERVER_MESSAGE)
        {
          AnsiString s;
          s =  ": " + str.SubString(strlen(MESS_SERVER_MESSAGE) + 1, str.Length());
          MessageBox(Handle, s.c_str(), "", MB_OK | MB_ICONINFORMATION);
          delete buffer;
          return;
        }
      if (str.SubString(1, strlen(MESS_SERVER_CLOSE_GAME)) == MESS_SERVER_CLOSE_GAME)
        {
          MessageBox(Handle, "    !", WINDOW_TITLE, MB_OK | MB_ICONINFORMATION);
          delete buffer;
          return;
        }
      SetData(buffer);
      delete buffer;
    };
//----------------------------------------------------
//   
  void __fastcall NewLocalGame(void)
    {
      type_game = TG_LOCAL;
      obj_table->FreeObj();
      SetActiveBtn(true);
      names[0] = frmNewGame->edName->Text;
      names[1] = frmNewGame->edCName->Text;
      int PrX, PrY;
      for (PrX = 0; PrX < 2; PrX++)
        {
          for (PrY = 0; PrY < 36; PrY++)
            {
              kart_user[PrX][PrY] = TK_NONE;
            }
        }
      for (PrX = 0; PrX < 12; PrX++)
        {
          kart_table[PrX] = TK_NONE;
        }
      size_kart_user[0] = 0;
      size_kart_user[1] = 0;
      size_kart_table = 0;
      StartLocalGame();
    };
  void __fastcall StartLocalGame(void)
    {
      obj_table->CreateObj();
      obj_log->NewGame();
      obj_log->SetKartToTable(2);
      LocalDraw();
      StepGame();
    };
  void __fastcall CloseLocalGame(void)
    {
      obj_table->FreeObj();
      SetActiveBtn(false);
      SetInfo("");
      sbOK->Visible = false;
    };
//----------------------------------------------------
//  
//----------------------------------------------------
//    
  void __fastcall SetActiveBtn(bool fl)
    {
      if (fl)
        {
          mmNew->Enabled = false;
          mmClose->Enabled = true;
          mmExit->Enabled = false;
          mmServer->Enabled = false;
          active_game = true;
        }
          else
            {
              mmNew->Enabled = true;
              mmClose->Enabled = false;
              mmExit->Enabled = true;
              mmServer->Enabled = true;
              active_game = false;
            }
    };
  void __fastcall SetFuncGame(void);
  void __fastcall SetInfo(AnsiString text)
    {
      lbInfo->Caption = text;
      lbInfo->Left = ClientWidth - lbInfo->Width - 8;
    };
  void __fastcall CopyToArr(int *buf_to, int *buf_from, int size)
    {
      for (int PrX = 0; PrX < size; PrX++)
        {
          buf_to[PrX] = buf_from[PrX];
        }
    };
  void __fastcall SetData(void *buffer)
    {
      TDurakData *data;
      int PrX, PrY;
      data = (TDurakData *)buffer;
      //  
      obj_table->SetAllUser(data->size_user);
      //  
      for (PrX = 0; PrX < data->size_user; PrX++)
        {
          obj_table->SetUserAllKarts(PrX, &data->user[PrX][0], data->size_user_kart[PrX]);
        }
      if (data->my_id != 0)
        {
          obj_table->SetUserAllKarts(0, &data->user[data->my_id][0], data->size_user_kart[data->my_id]);
          obj_table->SetUserAllKarts(data->my_id, &data->user[0][0], data->size_user_kart[0]);
        }
      //  
      for (int PrX = 0; PrX < data->size_user; PrX++)
        {
          obj_table->SetNameUser(PrX, &data->name[PrX][0]);
        }
      if (data->my_id != 0)
        {
          obj_table->SetNameUser(0, &data->name[data->my_id][0]);
          obj_table->SetNameUser(data->my_id, &data->name[0][0]);
        }
      //  
      obj_table->SetKartToKolod(&data->kolod[0], data->size_kolod);
      //  
      obj_table->SetKartToTable(&data->table[0], data->size_table);
      //  
      obj_table->SetKartToBito(&data->bito[0], data->size_bito);
      // 
      obj_table->SetKozer(data->kozer);
      //  
      obj_table->SetParamKozer(data->fl_kozer);
      obj_table->SetParamToKart();
      obj_table->SetParamToKolod();
      obj_table->SetParamToKozer();
      obj_table->SetParamToTable();
      obj_table->SetTextureAllKarts();
      obj_table->SetTextureMyKarts();
      obj_table->SetTextureTableKarts();
      obj_table->DrawAllKartsToTable(true);
      obj_table->SetVisibleAllKarts(true);
      if (data->wstep == TU_NONE)
        {
          SetInfo("");
        }
      if (data->wstep == TU_STEP || data->wstep == TU_PODKID)
        {
          SetInfo("");
          sbOK->Caption = "";
          sbOK->Visible = true;
        }
      if (data->wstep == TU_OTBIV)
        {
          SetInfo("");
          sbOK->Caption = "";
          sbOK->Visible = true;
        }
      if (data->wstep == TU_NONE)
        {
          sbOK->Visible = false;
          SetInfo("");
        }
      wstep = data->wstep;
  };
//----------------------------------------------------
//    
  void __fastcall CopyMem(void *buf_to, void *buf_from, int size)
    {
      char *to;
      char *from;
      to = (char *)buf_to;
      from = (char *)buf_from;
      for (int PrX = 0; PrX < size; PrX++)
        {
          to[PrX] = from[PrX];
        }
    };
  void __fastcall LocalDraw(void)
    {
      TDurakData *data;
      int PrX, PrY;
      data = new TDurakData();
      //  
      data->kozer = obj_log->GetKozer();
      //   
      data->fl_kozer = obj_log->GetParamKozer();
      //   
      data->size_user = obj_log->GetSizeUsers();
      for (PrX = 0; PrX < obj_log->GetSizeUsers(); PrX++)
        {
          //   
          data->size_user_kart[PrX] = obj_log->GetSizeKartForUser(PrX);
          size_kart_user[PrX] = obj_log->GetSizeKartForUser(PrX);
          //   
          for (PrY = 0; PrY < obj_log->GetSizeKartForUser(PrX); PrY++)
            {
              //    
              data->user[PrX][PrY] = obj_log->GetKart(PrX, PrY);
              kart_user[PrX][PrY] = obj_log->GetKart(PrX, PrY);
            }
        }
      //     
      data->size_kolod = obj_log->GetAllKartForBito();
      for (PrX = 0; PrX < obj_log->GetAllKartForBito(); PrX++)
        {
          //   
          data->kolod[PrX] = obj_log->GetKartBito(PrX);
        }
      //     
      data->size_table = obj_log->GetSizeTableKart();
      size_kart_table = obj_log->GetSizeTableKart();
      for (PrX = 0; PrX < obj_log->GetSizeTableKart(); PrX++)
        {
          //    
          data->table[PrX] = obj_log->GetIntexKartForTable(PrX);
          kart_table[PrX] = obj_log->GetIntexKartForTable(PrX);
        }
      //     
      data->size_bito = obj_log->GetSizeBitoB();
      for (PrX = 0; PrX < obj_log->GetSizeBitoB(); PrX++)
        {
          //    
          data->bito[PrX] = obj_log->GetKartBitoB(PrX);
        }
      //  
      CopyMem(&data->name[0][0], names[0].c_str(), names[0].Length());
      data->name[0][names[0].Length()] = 0;
      CopyMem(&data->name[1][0], names[1].c_str(), names[1].Length());
      data->name[1][names[1].Length()] = 0;
      //   
      data->my_id = 0;
      //  
      data->wstep = obj_log->GetParamwStep(0);
      SetData(data);
      delete data;
    };
  void __fastcall StepGame(void)
    {
      NextAIStep();
    };
//----------------------------------------------------
//   
  void __fastcall NextAIStep(void)
    {
      if (obj_log->GetParamwStep(1) == TU_STEP || obj_log->GetParamwStep(1) == TU_PODKID)
        {
          AIStep();
        }
      if (obj_log->GetParamwStep(1) == TU_OTBIV)
        {
          AIOtbiv();
        }
    };
  void __fastcall GetObl(int parKart, int &min, int &max)
    { //      
      if (CR_CHERVY(parKart))
        {
          min = 0;
          max = 8;
        }
      if (CR_BUBY(parKart))
        {
          min = 9;
          max = 17;
        }
      if (CR_PIKY(parKart))
        {
          min = 18;
          max = 26;
        }
      if (CR_KRESTY(parKart))
        {
          min = 27;
          max = 35;
        }
    };    
  bool __fastcall KartKozer(int ind)
    {
      int k_min;
      int k_max;
      GetObl(obj_log->GetKozer(), k_min, k_max);
      if (ind >= k_min && ind <= k_max)
        {
          return true;
        }
          else
            {
              return false;
            }
    };
  int __fastcall GetMinAIKart(void)
    {
      int min;
      min = 36;
      for (int PrX = 0; PrX < size_kart_user[1]; PrX++)
        {
          if (kart_user[1][PrX] < min && !KartKozer(kart_user[1][PrX]))
            {
              min = kart_user[1][PrX];
            }
        }
      if (min == 36)
        {
          for (int PrX = 0; PrX < size_kart_user[1]; PrX++)
            {
              if (kart_user[1][PrX] < min)
                {
                  min = kart_user[1][PrX];
                }
            }
        }
      return min;
    };
  bool __fastcall OKAIPodkid(int ind_kart)
    {
      int start;
      if ((ind_kart - 9) < 0)
        {
          start = ind_kart;
        }
          else
            if ((ind_kart - 18) < 0)
              {
                start = ind_kart - 9;
              }
                else
                  {
                    if ((ind_kart - 27) < 0)
                      {
                        start = ind_kart - 18;
                      }
                        else
                          {
                            start = ind_kart - 27;
                          }
                  }
      int PrX, PrY;
      for (PrX = 0; PrX < size_kart_table; PrX++)
        {
          for (PrY = start; PrY < 36; PrY += 9)
            {
              if (kart_table[PrX] == PrY)
                {
                  return true;
                }
            }
        }
      return false;
    };
  void __fastcall GetAIPodkid(void)
    {
      int kr;
      kr = -1;
      for (int PrX = 0; PrX < size_kart_user[1]; PrX++)
        {
          if (!KartKozer(kart_user[1][PrX]))
            {
              if (OKAIPodkid(kart_user[1][PrX]))
                {
                  kr = kart_user[1][PrX];
                }
            }    
        }
      if (kr == -1)
        { //   , 
          for (int PrX = 0; PrX < size_kart_user[1]; PrX++)
            {
              if (OKAIPodkid(kart_user[1][PrX]))
                {
                  kr = kart_user[1][PrX];
                }
            }
          if (kr != -1)
            {
              obj_log->SetStep(1, kr);
              LocalDraw();
            }
              else
                {
                  obj_log->SetNextStepA();
                  LocalDraw();
                }  
        }
          else
            { //   , 
              obj_log->SetStep(1, kr);
              LocalDraw();
            }
    };
  void __fastcall AIStep(void)
    {
      int sTable;
      sTable = obj_log->GetSizeTableKart();
      if (sTable == 0)
        { //  
          int m_kart;
          m_kart = GetMinAIKart();
          obj_log->SetStep(1, m_kart);
          LocalDraw();
          if (!obj_log->GetParamKozer() && obj_log->GetAllKartForBito() == 0 && obj_log->GetSizeKartForUser(1) == 0)
            {
              InfoIfEndGame();
            }
        }
          else
            { //  
              GetAIPodkid();
              if (!obj_log->GetParamKozer() && obj_log->GetAllKartForBito() == 0 && obj_log->GetSizeKartForUser(1) == 0)
                {
                  InfoIfEndGame();
                }
            }
    };
  void __fastcall AIOtbiv(void)
    {
      bool kz;
      kz = KartKozer(kart_table[size_kart_table - 1]);
      if (kz)
        { //   
          int m_kz;
          m_kz = -1;
          for (int PrX = 0; PrX < size_kart_user[1]; PrX++)
            {
              if (KartKozer(kart_user[1][PrX]))
                {
                  if (kart_user[1][PrX] > kart_table[size_kart_table - 1])
                    {
                      m_kz = kart_user[1][PrX];
                      break;
                    }
                }
            }
          if (m_kz != -1)
            {
              obj_log->SetStep(1, m_kz);
              LocalDraw();
            }
              else
                {
                  obj_log->SetZabirau();
                  LocalDraw();                  
                }
        }
          else
            {
              int min;
              int max;
              int kr;
              kr = 36;
              GetObl(kart_table[size_kart_table - 1], min, max);
              for (int PrX = 0; PrX < size_kart_user[1]; PrX++)
                {
                  if (kart_user[1][PrX] > kart_table[size_kart_table - 1] &&
                    kart_user[1][PrX] <= max && kart_user[1][PrX] < kr)
                      {
                        kr = kart_user[1][PrX];
                      }
                }
              if (kr == 36)
                { //     
                  int kz_kart;
                  int test_kozer_min;
                  int test_kozer_max;
                  kz_kart = 36;
                  GetObl(obj_log->GetKozer(), test_kozer_min, test_kozer_max);
                  for (int PrX = 0; PrX < size_kart_user[1]; PrX++)
                    {
                      if (kart_user[1][PrX] >= test_kozer_min &&
                        kart_user[1][PrX] <= test_kozer_max && kart_user[1][PrX] < kz_kart)
                          {
                            kz_kart = kart_user[1][PrX];
                          }
                    }
                  if (kz_kart == 36)
                    { //  , 
                      obj_log->SetZabirau();
                      LocalDraw();
                    }
                      else
                        { //  , 
                          obj_log->SetStep(1, kz_kart);
                          LocalDraw(); 
                        }
                }
                  else
                    { //     
                      obj_log->SetStep(1, kr);
                      LocalDraw();
                    }
            }
    };
  void __fastcall InfoIfEndGame(void)
    {
      if (obj_log->GetAllKartForBito() == 0)
        {
          if (!obj_log->GetParamKozer())
            {
              if (size_kart_user[0] == 0 && size_kart_user[1] == 0)
                {
                  SoundPlay(SOUND_END_GAME_V);
                  if (MessageBox(Handle, " !     ?", WINDOW_TITLE, MB_YESNO | MB_ICONQUESTION) == 6)
                    {
                      NewLocalGame();
                    }
                      else
                        {
                          CloseLocalGame();
                        }
                }
                  else
                    {
                      if (size_kart_user[0] == 0 && size_kart_user[1] > 0)
                        {
                          SoundPlay(SOUND_END_GAME_V);
                          if (MessageBox(Handle, "  !     ?", WINDOW_TITLE, MB_YESNO | MB_ICONQUESTION) == 6)
                            {
                              NewLocalGame();
                            }
                              else
                                {
                                  CloseLocalGame();
                                }
                        }
                      if (size_kart_user[1] == 0 && size_kart_user[0] > 0)
                        {
                          SoundPlay(SOUND_END_GAME_P);
                          if (MessageBox(Handle, "  !     ?", WINDOW_TITLE, MB_YESNO | MB_ICONQUESTION) == 6)
                            {
                              NewLocalGame();
                            }
                              else
                                {
                                  CloseLocalGame();
                                }
                        }
                    }
            }
        }
    };
//----------------------------------------------------
//   
  TProgramOption *__fastcall LoadFileParam(AnsiString path)
    {
      TProgramOption *opt;
      FILE *F;
      F = fopen(path.c_str(), "rb");
      if (F)
        {
          opt = new TProgramOption();
          fread(opt, sizeof(TProgramOption), 1, F);
          fclose(F);
          return opt;
        }
          else
            {
              return NULL;
            }
    };
  void __fastcall SaveFileParam(AnsiString path, TProgramOption *opt)
    {
      FILE *F;
      F = fopen(path.c_str(), "wb");
      if (F)
        {
          fwrite(opt, sizeof(TProgramOption), 1, F);
          fclose(F);
        }
    };
  void __fastcall SetProgramParam(void)
    {
      obj_table->SetParamGraph(sys_path + "image\\obl" + IntToStr(option->image) + ".jpg");
      if (FileExists(sys_path + "image\\fon" + IntToStr(option->image_f) + ".jpg"))
        {
          imFon->Picture->LoadFromFile(sys_path + "image\\fon" + IntToStr(option->image_f) + ".jpg");
        }
      lbInfo->BringToFront();
      sbOK->BringToFront();  
    };
  void __fastcall SoundPlay(int t_sound)
    {
      if (!option->sound)
        {
          return;
        }
      AnsiString path;
      if (t_sound == SOUND_KART)
        {
          if (option->sound_k == 0)
            {
              path = sys_path + "sound\\" + FILE_SOUND_VOSKL;
            }
          if (option->sound_k == 1)
            {
              path = sys_path + "sound\\" + FILE_SOUND_DIN;
            }
        }
      if (t_sound == SOUND_END_GAME_V)
        {
          path = sys_path + "sound\\" + FILE_SOUND_VIIGRAL;
        }
      if (t_sound == SOUND_END_GAME_P)
        {
          path = sys_path + "sound\\" + FILE_SOUND_PROIGRAL;
        }
      sound->FileName = path;
      sound->Open();
      sound->Play();
    };
  void __fastcall SetAllOblToComponent(void)
    {
      AnsiString path;
      path = sys_path + "image\\obl";
      frmOption->cbObl->Items->Clear();
      for (int PrX = 0; PrX < 20; PrX++)
        {
          if (FileExists(path + IntToStr(PrX) + ".jpg"))
            {
              frmOption->cbObl->Items->Add(" " + IntToStr(PrX + 1)); 
            }
        }
    };
  void __fastcall SetAllFonToComponent(void)
    {
      AnsiString path;
      path = sys_path + "image\\fon";
      frmOption->cbFon->Items->Clear();
      for (int PrX = 0; PrX < 20; PrX++)
        {
          if (FileExists(path + IntToStr(PrX) + ".jpg"))
            {
              frmOption->cbFon->Items->Add(" " + IntToStr(PrX + 1)); 
            }
        }
    };
//   
  void __fastcall SetParamDrawTable(void)
    {
      //    
      obj_table->SetSizeParam(PR_KART, 0, 0, 0, 71, 96);
      obj_table->SetSizeParam(PR_KART, 1, 0, 0, 71, 96);
      obj_table->SetSizeParam(PR_OBL, 0, 8, ClientHeight - 140, ClientWidth - 113, 200);
      obj_table->SetSizeParam(PR_OBL, 1, 8, 8, ClientWidth - 113, 200);
      obj_table->SetSizeParam(PR_KOZER, 0, 0, 0, 47, 64);
      obj_table->SetSizeParam(PR_KOLOD, 0, ClientWidth - 133, 24, 47, 64);
      obj_table->SetSizeParam(PR_TABLE, 0, 0, 0, 71, 96);
      obj_table->SetSizeParam(PR_TABLE_OBL, 0, 150, ClientHeight / 2 - 110, ClientWidth - 163, ClientHeight / 2 + 110);
      obj_table->SetSizeParam(PR_KART, 2, 0, 0, 47, 64);
      obj_table->SetSizeParam(PR_OBL, 2, 8, 136, 81, 0);
      obj_table->SetSizeParam(PR_KART, 3, 0, 0, 47, 64);
      obj_table->SetSizeParam(PR_OBL, 3, 8, Height - 302, 81, 0);
      obj_table->SetSizeParam(PR_KART, 4, 0, 0, 47, 64);
      obj_table->SetSizeParam(PR_OBL, 4, Width - 94, 136, Width - 94 + 73, 0);
      obj_table->SetSizeParam(PR_KART, 5, 0, 0, 47, 64);
      obj_table->SetSizeParam(PR_OBL, 5, Width - 94, Height - 302, Width - 94 + 73, 0);
      obj_table->SetStepToKolod(2, 1);
      if (active_game == true)
        {
          obj_table->DrawAllKartsToTable(true);
        }
    };
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmProg *frmProg;
//---------------------------------------------------------------------------
#endif
