//---------------------------------------------------------------------------

#ifndef FormMusicH
#define FormMusicH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Buttons.hpp>
#include <Dialogs.hpp>
#include <MPlayer.hpp>
//---------------------------------------------------------------------------
#define FILE_LIST_MUSIC           "music.list"
//---------------------------------------------------------------------------
class TfrmProg : public TForm
{
__published:
        TListBox *lbMusic;
        TStatusBar *stBar;
        TLabel *Label1;
        TSpeedButton *sbOpen;
        TSpeedButton *sbBack;
        TSpeedButton *sbFirst;
        TSpeedButton *sbPlay;
        TSpeedButton *sbNext;
        TSpeedButton *sbLast;
        TOpenDialog *od;
        TSpeedButton *sbDelete;
        TMediaPlayer *med;
        TSpeedButton *sbStop;
        void __fastcall FormShow(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall sbOpenClick(TObject *Sender);
        void __fastcall sbDeleteClick(TObject *Sender);
        void __fastcall sbPlayClick(TObject *Sender);
        void __fastcall sbFirstClick(TObject *Sender);
        void __fastcall sbBackClick(TObject *Sender);
        void __fastcall sbLastClick(TObject *Sender);
        void __fastcall sbNextClick(TObject *Sender);
        void __fastcall sbStopClick(TObject *Sender);
private:
  TStringList *lbPath;
  int play;
  bool fl_pause;
  AnsiString __fastcall GetMusicName(AnsiString text)
    {
      int PrX, PrY;
      for (PrX = 0; PrX < text.Length(); PrX++)
        {
          if (text[PrX] == '\\')
            {
              PrY = PrX;
            }
        }
      return text.SubString(PrY + 1, text.Length());
    };
public:
  __fastcall TfrmProg(TComponent* Owner);
  AnsiString sys_path;
  void __fastcall LoadListToObject(void)
    {
      lbMusic->Items->Clear();
      for (int PrX = 0; PrX < lbPath->Count; PrX++)
        {
          lbMusic->Items->Add(GetMusicName(lbPath->Strings[PrX]));
        }
    };
  void __fastcall StartPlay(int index)
    {
      if (fl_pause)
        {
          med->Play();
          return;
        }
      med->Stop();
      med->Close();
      med->FileName = lbPath->Strings[index];
      med->Open();
      med->Play();
      play = index;
      fl_pause = false;
    };
  void __fastcall StopPlay(void)
    {
      med->Stop();
      med->Close();
      play = -1;
    };
  void __fastcall PausePlay(void)
    {
      med->Pause();
      fl_pause = true;
    };
  void __fastcall DeleteListMusic(int index)
    {
      if (play == index)
        {
          StopPlay();
        }
      lbPath->Delete(index);
      lbMusic->Items->Delete(index);
    };
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmProg *frmProg;
//---------------------------------------------------------------------------
#endif
