#ifndef __MOD_OBJECT_GAME_DURAK__
#define __MOD_OBJECT_GAME_DURAK__
//---------------------------------------------------------------------------
#define CR_CHERVY(p)              (p >= 0 && p <= 8)
#define CR_BUBY(p)                (p >= 9 && p <= 17)
#define CR_PIKY(p)                (p >= 18 && p <= 26)
#define CR_KRESTY(p)              (p >= 27 && p <= 35)
//---------------------------------------------------------------------------
#define TU_NONE                   0
#define TU_STEP                   1
#define TU_OTBIV                  2
#define TU_PODKID                 3
//---------------------------------------------------------------------------
#define TK_NONE                   -1
//---------------------------------------------------------------------------
#define ALL_OTBIT                 0
//---------------------------------------------------------------------------
#define PR_KART                   1
#define PR_OBL                    2
#define PR_KOLOD                  3
#define PR_KOZER                  4
#define PR_TABLE                  5
#define PR_TABLE_OBL              6
//---------------------------------------------------------------------------
#define GM_MOUSE_DOWN             0
//---------------------------------------------------------------------------
typedef struct
{
  int left;
  int top;
  int width;
  int height;
} TParamSize;
//---------------------------------------------------------------------------
typedef void (TCallBackFunc(int type_message, AnsiString param));
//---------------------------------------------------------------------------
class TDurakTable
{
private:
  AnsiString __fastcall GetStringKozer(void)
    { //   
      if (CR_CHERVY(kozer))
        {
          return ": ";
        }
      if (CR_BUBY(kozer))
        {
          return ": ";
        }
      if (CR_PIKY(kozer))
        {
          return ": ";
        }
      if (CR_KRESTY(kozer))
        {
          return ": ";        
        }
      return "";  
    };
//   
  TWinControl *owner; //  
  AnsiString i_path; //   
  AnsiString i_path_obl; //    
  HWND handle; //   
  TLabel *lb[6]; //    
  TLabel *lb_kozer; //    
  TCallBackFunc *func; //   
//----------------------------------------------------
//  : 
  TImage *t_kart[36]; //   
  int size_user; //  
  int i_kart[6][36]; //    
  int size_us_kart[6]; //     
  int size_kart_table; //    
  int kart_table[12]; //   
  int kozer; //   
  int step_to_kolod_x; //       X
  int step_to_kolod_y; //       Y
  int size_kart_kolod; //    
  int kart_kolod[36]; //   
  int size_kart_bito; //    
  int kart_bito[36]; //   
  AnsiString name_user[6]; //  
  TParamSize size_kart[6]; //   
  TParamSize size_kart_obl[6]; //      
  TParamSize size_kolod; //      
  TParamSize size_kozer; //   
  TParamSize size_table; //     
  TParamSize size_table_obl; //      
  bool fl_kozer; //     
//----------------------------------------------------
  void __fastcall mDown(TObject *Sender,
    TMouseButton Button, TShiftState Shift, int X, int Y)
      {
        AnsiString str;
        if (Button == mbLeft)
          {
            str = "l";
          }
            else
              {
                str = "r";
              }
        str = str + ((TImage *)Sender)->Name.SubString(5, ((TImage *)Sender)->Name.Length());
        func(GM_MOUSE_DOWN, str);
      };
public:
  __fastcall TDurakTable(TWinControl *__owner, AnsiString __i_path, AnsiString __i_path_obl, HWND __handle)
    {
      owner = __owner;
      i_path = __i_path;
      i_path_obl = __i_path_obl;
      handle = __handle;
      for (int PrX = 0; PrX < 36; PrX++)
        {
          t_kart[PrX] = NULL;
        }
      for (int PrX = 0; PrX < 6; PrX++)
        {
          lb[PrX] = NULL;
        }
      lb_kozer = NULL;
    };
  __fastcall ~TDurakTable(void)
    {
      FreeObj();
    };
  void __fastcall CreateObj(void)
    {
      int PrX, PrY;
      size_user = 0;
      size_kart_table = 0;
      kozer = TK_NONE;
      step_to_kolod_x = 1;
      step_to_kolod_y = 1;
      size_kart_kolod = 0;
      size_kart_bito = 0;
      fl_kozer = true;
      for (PrX = 0; PrX < 36; PrX++)
        {
          t_kart[PrX] = new TImage(owner);
          t_kart[PrX]->Name = "KART" + IntToStr(PrX);
          t_kart[PrX]->Parent = owner;
          t_kart[PrX]->OnMouseDown = mDown;
          t_kart[PrX]->Visible = false;
          t_kart[PrX]->AutoSize = false;
          t_kart[PrX]->Stretch = true;
          kart_kolod[PrX] = TK_NONE;
          kart_bito[PrX] = TK_NONE;
        }
      for (PrX = 0; PrX < 6; PrX++)
        {
          lb[PrX] = new TLabel(owner);
          lb[PrX]->Name = "LABEL" + IntToStr(PrX);
          lb[PrX]->Parent = owner;
          lb[PrX]->AutoSize = true;
          lb[PrX]->Visible = false;
          lb[PrX]->Transparent = true;
        }
      lb_kozer = new TLabel(owner);
      lb_kozer->Name = "lb_kozer";
      lb_kozer->Parent = owner;
      lb_kozer->Caption = "";
      lb_kozer->AutoSize = true;
      lb_kozer->Visible = false;
      lb_kozer->Font->Size = 14;
      lb_kozer->Font->Color = clBlue;
      lb_kozer->Transparent = true;
      for (PrX = 0; PrX < 6; PrX++)
        {
          for (PrY = 0; PrY < 36; PrY++)
            {
              i_kart[PrX][PrY] = TK_NONE;
            }
          size_us_kart[PrX] = 0;
        }
      for (PrX = 0; PrX < 12; PrX++)
        {
          kart_table[PrX] = TK_NONE;
        }
    };
  void __fastcall FreeObj(void)
    {
      for (int PrX = 0; PrX < 36; PrX++)
        {
          if (t_kart[PrX])
            {
              delete t_kart[PrX];
              t_kart[PrX] = NULL;
            }
        }
      for (int PrX = 0; PrX < 6; PrX++)
        {
          if (lb[PrX])
            {
              delete lb[PrX];
              lb[PrX] = NULL;
            }
        }
      delete lb_kozer;
      lb_kozer = NULL;
    };
  bool __fastcall SetSizeParam(int type_param, int ind, int left, int top,
    int width, int height)
      {
        if (type_param == PR_KART)
          {
            size_kart[ind].left = left;
            size_kart[ind].top = top;
            size_kart[ind].width = width;
            size_kart[ind].height = height;
            return true;
          }
        if (type_param == PR_OBL)
          {
            size_kart_obl[ind].left = left;
            size_kart_obl[ind].top = top;
            size_kart_obl[ind].width = width;
            size_kart_obl[ind].height = height;
            return true;
          }
        if (type_param == PR_KOLOD)
          {
            size_kolod.left = left;
            size_kolod.top = top;
            size_kolod.width = width;
            size_kolod.height = height;
            return true;
          }
        if (type_param == PR_KOZER)
          {
            size_kozer.left = left;
            size_kozer.top = top;
            size_kozer.width = width;
            size_kozer.height = height;
            return true;
          }
        if (type_param == PR_TABLE)
          {
            size_table.left = left;
            size_table.top = top;
            size_table.width = width;
            size_table.height = height;
            return true;
          }
        if (type_param == PR_TABLE_OBL)
          {
            size_table_obl.left = left;
            size_table_obl.top = top;
            size_table_obl.width = width;
            size_table_obl.height = height;
          }
        return false;
      };
  void __fastcall SetParamToKart(void)
    {
      int PrX, PrY;
      for (PrX = 0; PrX < size_user; PrX++)
        {
          for (PrY = 0; PrY < size_us_kart[PrX]; PrY++)
            {
              t_kart[i_kart[PrX][PrY]]->Width = size_kart[PrX].width;
              t_kart[i_kart[PrX][PrY]]->Height = size_kart[PrX].height;
            }
        }
    };
  void __fastcall SetParamToKolod(void)
    {
      for (int PrX = 0; PrX < size_kart_kolod; PrX++)
        {
          t_kart[kart_kolod[PrX]]->Width = size_kolod.width;
          t_kart[kart_kolod[PrX]]->Height = size_kolod.height;
        }
    };
  void __fastcall SetParamToKozer(void)
    {
      if (fl_kozer)
        {
          t_kart[kozer]->Width = size_kozer.width;
          t_kart[kozer]->Height = size_kozer.height;
        }
    }
  void __fastcall SetParamToTable(void)
    {
      for (int PrX = 0; PrX < size_kart_table; PrX++)
        {
          t_kart[kart_table[PrX]]->Width = size_table.width;
          t_kart[kart_table[PrX]]->Height = size_table.height;
        }
    };
  void __fastcall SetAllUser(int sz)
    {
      size_user = sz;
    };
  void __fastcall SetKozer(int ind_kart)
    {
      kozer = ind_kart;
    };
  void __fastcall SetUserAllKarts(int user, int *mass, int size)
    {
      size_us_kart[user] = size;
      for (int PrX = 0; PrX < size; PrX++)
        {
          i_kart[user][PrX] = mass[PrX];
        }
    };
  void __fastcall SetKartToTable(int *mass, int size)
    {
      size_kart_table = size;
      for (int PrX = 0; PrX < size; PrX++)
        {
          kart_table[PrX] = mass[PrX];
        }
    };
  void __fastcall SetKartToKolod(int *mass, int size)
    {
      size_kart_kolod = size;
      for (int PrX = 0; PrX < size; PrX++)
        {
          kart_kolod[PrX] = mass[PrX];
        }
    };
  void __fastcall SetKartToBito(int *mass, int size)
    {
      size_kart_bito = size;
      for (int PrX = 0; PrX < size; PrX++)
        {
          kart_bito[PrX] = mass[PrX];
          t_kart[kart_bito[PrX]]->Visible = false;
        }
    };
  void __fastcall SetTextureMyKarts(void)
    {
      //     
      if (size_us_kart[0] > 0)
        {
          for (int PrX = 0; PrX < size_us_kart[0]; PrX++)
            {
              t_kart[i_kart[0][PrX]]->Picture->LoadFromFile(i_path + IntToStr(i_kart[0][PrX]) + ".jpg");
            }
        }
      if (fl_kozer)
        {
          t_kart[kozer]->Picture->LoadFromFile(i_path + IntToStr(kozer) + ".jpg");
        }  
    };
  bool __fastcall MyKart(int ind)
    {
      bool fl;
      fl = false;
      for (int PrX = 0; PrX < size_us_kart[0]; PrX++)
        {
          if (ind == i_kart[0][PrX])
            {
              fl = true;
            }
        }
      return fl;
    };
  void __fastcall SetTextureAllKarts(void)
    {
      for (int PrX = 0; PrX < 36; PrX++)
        {
          if (!MyKart(PrX))
            {
              t_kart[PrX]->Picture->LoadFromFile(i_path_obl);
            }
        }
    };
  void __fastcall SetTextureTableKarts(void)
    {
      for (int PrX = 0; PrX < size_kart_table; PrX++)
        {
          t_kart[kart_table[PrX]]->Picture->LoadFromFile(i_path + IntToStr(kart_table[PrX]) + ".jpg");
        }
    };
  void __fastcall DrawKarts(int ind_user, bool up)
    {
      if (size_us_kart[ind_user] == 0)
        {
          return;
        }
      int step;
      int psx;
      int psy;
      step = (size_kart_obl[ind_user].width -
        size_kart_obl[ind_user].left - size_kart[ind_user].width) /
          size_us_kart[ind_user];
      psx = size_kart_obl[ind_user].left;
      psy = size_kart_obl[ind_user].top + 16;
      for (int PrX = 0; PrX < size_us_kart[ind_user]; PrX++)
        {
          t_kart[i_kart[ind_user][PrX]]->Left = psx;
          t_kart[i_kart[ind_user][PrX]]->Top = psy;
          psx += step;
        }
      lb[ind_user]->Left = size_kart_obl[ind_user].left;
      lb[ind_user]->Top = size_kart_obl[ind_user].top;
      lb[ind_user]->Font->Color = clRed;
      lb[ind_user]->Caption = name_user[ind_user];
      lb[ind_user]->Visible = true;
      if (up)
        {
          SetUpKarts(ind_user, -1);
        }
    };
  void __fastcall DrawKartToKolod(bool up)
    {
      if (size_kart_kolod == 0 && !fl_kozer)
        {
          lb_kozer->Caption = GetStringKozer();
          lb_kozer->Left = size_kolod.left - size_kolod.width / 2;
          lb_kozer->Top = size_kolod.top;
          lb_kozer->Visible = true;
          return;
        }
          else
            {
              lb_kozer->Visible = false;
            }
      if (fl_kozer)
        {
          t_kart[kozer]->Left = size_kolod.left - size_kolod.width / 2;
          t_kart[kozer]->Top = size_kolod.top;
        }
      if (size_kart_kolod == 0)
        {
          return;
        }
      int psx;
      int psy;
      psx = size_kolod.left;
      psy = size_kolod.top;
      for (int PrX = 0; PrX < size_kart_kolod; PrX++)
        {
          t_kart[kart_kolod[PrX]]->Left = psx;
          t_kart[kart_kolod[PrX]]->Top = psy;
          psx += step_to_kolod_x;
          psy += step_to_kolod_y;
        }
      if (up)
        {
          SetUpKartsToKolod();
        }
    };
  void __fastcall DrawAllKartsToTable(bool up)
    {
      for (int PrX = 0; PrX < size_user; PrX++)
        {
          DrawKarts(PrX, up);
        }
      DrawKartToKolod(up);
      DrawKartToTable(up);
    };
  void __fastcall SetUpKarts(int user, int kart_up)
    {
      for (int PrX = 0; PrX < size_us_kart[user]; PrX++)
        {
          t_kart[i_kart[user][PrX]]->BringToFront();
        }
      if (kart_up != -1)
        {
          t_kart[kart_up]->BringToFront();
        }
    };
  void __fastcall SetUpKartsToKolod(void)
    {
      t_kart[kozer]->BringToFront();
      for (int PrX = 0; PrX < size_kart_kolod; PrX++)
        {
          t_kart[kart_kolod[PrX]]->BringToFront();
        }
    }
  void __fastcall SetVisibleAllKarts(bool visible)
    {
      int PrX, PrY;
      for (PrX = 0; PrX < 36; PrX++)
        {
          t_kart[PrX]->Visible = false;
        }
      for (PrX = 0; PrX < size_user; PrX++)
        {
          for (PrY = 0; PrY < size_us_kart[PrX]; PrY++)
            {
              t_kart[i_kart[PrX][PrY]]->Visible = visible;
            }
        }
      for (PrX = 0; PrX < size_kart_kolod; PrX++)
        {
          t_kart[kart_kolod[PrX]]->Visible = visible;
        }
      for (PrX = 0; PrX < size_kart_table; PrX++)
        {
          t_kart[kart_table[PrX]]->Visible = visible;
        }
      t_kart[kozer]->Visible = visible;
      for (int PrX = 0; PrX < size_kart_bito; PrX++)
        {
          t_kart[kart_bito[PrX]]->Visible = false;
        }
    };
  void __fastcall SetStepToKolod(int step_x, int step_y)
    {
      step_to_kolod_x = step_x;
      step_to_kolod_y = step_y;
    };
  void __fastcall SetNameUser(int ind_user, AnsiString name)
    {
      name_user[ind_user] = name;
    };
  void __fastcall DrawKartToTable(bool up)
    {
      if (size_kart_table == 0)
        {
          return;
        }
      int psx;
      int psy1;
      int psy2;
      int step;
      step = (size_table_obl.width - size_table_obl.left - size_table.width) / size_kart_table;
      psx = size_table_obl.left;
      psy1 = size_table_obl.top;
      psy2 = size_table_obl.height - size_table.height;
      for (int PrX = 0; PrX < size_kart_table; PrX += 2)
        {
          t_kart[kart_table[PrX]]->Left = psx;
          t_kart[kart_table[PrX]]->Top = psy1;
          psx += step;
        }
      psx = size_table_obl.left;
      for (int PrX = 1; PrX < size_kart_table; PrX += 2)
        {
          t_kart[kart_table[PrX]]->Left = psx;
          t_kart[kart_table[PrX]]->Top = psy2;
          psx += step;
        }
      if (up)
        {
          SetUpKartToTable();
        }
    };
  void __fastcall SetUpKartToTable(void)
    {
      for (int PrX = 0; PrX < size_kart_table; PrX += 2)
        {
          t_kart[kart_table[PrX]]->BringToFront();
        }
      for (int PrX = 1; PrX < size_kart_table; PrX += 2)
        {
          t_kart[kart_table[PrX]]->BringToFront();
        }
    };
  void __fastcall SetCallBackFunc(TCallBackFunc *__func)
    {
      func = __func;
    };
  void __fastcall SetParamKozer(bool pr)
    {
      fl_kozer = pr;
    };
  void __fastcall SetParamGraph(AnsiString __i_path_obl)
    {
      i_path_obl = __i_path_obl;
    };
};
//---------------------------------------------------------------------------
#endif
