#ifndef __MOD_DURAK_PROG__
#define __MOD_DURAK_PROG__
//---------------------------------------------------------------------------
#define CR_CHERVY(p)              (p >= 0 && p <= 8)
#define CR_BUBY(p)                (p >= 9 && p <= 17)
#define CR_PIKY(p)                (p >= 18 && p <= 26)
#define CR_KRESTY(p)              (p >= 27 && p <= 35)
//---------------------------------------------------------------------------
#define TU_NONE                   0
#define TU_STEP                   1
#define TU_OTBIV                  2
#define TU_PODKID                 3
//---------------------------------------------------------------------------
#define TK_NONE                   -1
//---------------------------------------------------------------------------
#define ALL_OTBIT                 0
//---------------------------------------------------------------------------
#include <math.h>
//---------------------------------------------------------------------------
typedef void (TEv(int message));
//---------------------------------------------------------------------------
class TDurak
{
private:
  int skUser[6];
  int user[6][36];
  int sbKart;
  int bKart[36];
  int kozer;
  int sUser;
  int wStep[6];
  int skTable;
  int kTable[12];
  int sizepodkid;
  bool active[6];
  int sizeBito;
  int Bito[36];
  TEv *ev;
  bool fl_kozer;
public:
//    
  __fastcall TDurak(void) {};
  __fastcall ~TDurak(void) { FreeGame(); };
//     
  void __fastcall NewGame(void)
    { //  
      int PrX, PrY;
      for (PrX = 0; PrX < 6; PrX++)
        {
          for (PrY = 0; PrY < 36; PrY++)
            {
              user[PrX][PrY] = TK_NONE;
            }
        }
      for (PrX = 0; PrX < 36; PrX++)
        {
          bKart[PrX] = TK_NONE;
          if (PrX >= 0 && PrX < 6)
            {
              skUser[PrX] = 0;
            }
        }
      for (int PrX = 0; PrX < 6; PrX++)
        {
          wStep[PrX] = TU_NONE;
        }
      skTable = 0;
      for (int PrX = 0; PrX < 12; PrX++)
        {
          kTable[PrX] = TK_NONE;
        }
      SetParamActive(0, 0);
      sizepodkid = 0;
      sizeBito = 0;
      sbKart = 0;
      fl_kozer = true;
      for (int PrX = 0; PrX < 36; PrX++)
        {
          Bito[PrX] = TK_NONE;
        }
    };
  void __fastcall FreeGame(void)
    { //  
    };
//  
  void __fastcall SetKartToTable(int size)
    { //    
      sUser = size;
      int r;
      int sz;
      bool fl;
      fl = false;
      sz = 0;
      randomize();
      while (true)
        {
          r = random(36);
          fl = false;
          for (int PrX = 0; PrX < 36; PrX++)
            {
              if (bKart[PrX] == r)
                {
                  fl = true;
                }
            }
          if (!fl)
            {
              bKart[sz] = r;
              sz++;
              if (sz == 36)
                {
                  sbKart = 36;
                  break;
                }
            }
        }
      int PrX, PrY;
      for (PrX = 0; PrX < sUser; PrX++)
        {
          skUser[PrX] = 6;
          for (PrY = 0; PrY < 6; PrY++)
            {
              sbKart--;
              user[PrX][PrY] = bKart[sbKart];
              bKart[sbKart] = TK_NONE;
            }
        }
      if (sUser == 6)
        {
          kozer = user[5][5];
          fl_kozer = false;
        }
          else
            {
              sbKart--;
              kozer = bKart[sbKart];
              bKart[sbKart] = TK_NONE;
            }
      int ps;
      ps = GetOneStep();
      SetParamwStep(ps);
      SetParamActive(ps, 1);
    };
  void __fastcall GetObl(int parKart, int &min, int &max)
    { //      
      if (CR_CHERVY(parKart))
        {
          min = 0;
          max = 8;
        }
      if (CR_BUBY(parKart))
        {
          min = 9;
          max = 17;
        }
      if (CR_PIKY(parKart))
        {
          min = 18;
          max = 26;
        }
      if (CR_KRESTY(parKart))
        {
          min = 27;
          max = 35;
        }
    };
  int __fastcall GetMinKartForUser(void)
    { //      
      int smTestKart[6];
      int PrX, PrY;
      for (PrX = 0; PrX < 6; PrX++)
        {
          smTestKart[PrX] = 36;
        }
      for (PrX = 0; PrX < 6; PrX++)
        {
          for (PrY = 0; PrY < skUser[PrX]; PrY++)
            {
              if (user[PrX][PrY] < smTestKart[PrX])
                {
                  smTestKart[PrX] = user[PrX][PrY];
                }
            }
        }
      int min = 36;
      int us;
      for (PrX = 0; PrX < 6; PrX++)
        {
          if (smTestKart[PrX] < min)
            {
              min = smTestKart[PrX];
              us = PrX;
            }
        }
      return us;
    };
  int __fastcall GetOneStep(void)
    { //    
      int smTestKart[6];
      int PrX, PrY;
      int minKart;
      int maxKart;
      int testKart = 36;
      int sz;
      bool fl;
      for (PrX = 0; PrX < 6; PrX++)
        {
          smTestKart[PrX] = 36;
        }
      GetObl(kozer, minKart, maxKart);
      sz = 0;
      for (PrX = 0; PrX < sUser; PrX++)
        {
          fl = false;
          for (PrY = 0; PrY < skUser[PrX]; PrY++)
            {
              if (user[PrX][PrY] >= minKart && user[PrX][PrY] <= maxKart
                && user[PrX][PrY] < testKart)
                {
                  testKart = user[PrX][PrY];
                  fl = true;
                }
            }
          if (fl)
            {
              smTestKart[PrX] = testKart;
              testKart = 36;
              sz++;
            }
        }
      if (sz == 0)
        {
          return GetMinKartForUser();
        }
      int us;
      testKart = 36;
      for (PrX = 0; PrX < sUser; PrX++)
        {
          if (smTestKart[PrX] < testKart)
            {
              testKart = smTestKart[PrX];
              us = PrX;
            }
        }
      return us;
    };
  bool __fastcall GetOKPodkid(int ind_kart)
    {
      int ps;
      if (CR_CHERVY(ind_kart))
        {
          ps = ind_kart;
        }
      if (CR_BUBY(ind_kart))
        {
          ps = ind_kart - 9;
        }
      if (CR_PIKY(ind_kart))
        {
          ps = ind_kart - 18;
        }
      if (CR_KRESTY(ind_kart))
        {
          ps = ind_kart - 27;
        }
      int PrX, PrY;
      int _ps;
      for (PrX = 0; PrX < skTable; PrX++)
        {
          _ps = ps;
          for (int PrY = 0; PrY < 4; PrY++)
            {
              if (_ps != ind_kart)
                {
                  if (kTable[PrX] == _ps)
                    {
                      return true;
                    }
                }
              _ps += 9;
            }
        }
      return false;
    };
  bool __fastcall GetOtbilsia(int ind_kart)
    {
      int min;
      int max;
      GetObl(kTable[skTable - 1], min, max);
      if (ind_kart >= min && ind_kart <= max)
        { //   
          if (ind_kart > kTable[skTable - 1])
            {
              return true;
            }
        }
          else
            {
              int max_k;
              int min_k;
              GetObl(kozer, min_k, max_k);
              if (ind_kart >= min_k && ind_kart <= max_k)
                { //   
                  return true;
                }
            }
      return false;
    };
  void __fastcall DeleteKartForUser(int us, int ind_kart)
    {
      int ps;
      ps = -1;
      for (int PrX = 0; PrX < skUser[us]; PrX++)
        {
          if (user[us][PrX] == ind_kart)
            {
              ps = PrX;
            }
        }
      if (ps == -1)
        {
          MessageBox(NULL, "  !", "SYSTEM ERROR", MB_OK | MB_ICONERROR);
          return;
        }
      for (int PrX = ps + 1; PrX < skUser[us]; PrX++)
        {
          user[us][PrX - 1] = user[us][PrX];
        }
      skUser[us]--;
    };
  bool __fastcall UserKart(int us, int ind_kart)
    {
      for (int PrX = 0; PrX < skUser[us]; PrX++)
        {
          if (user[us][PrX] == ind_kart)
            {
              return true;
            }
        }
      return false;
    };
  bool __fastcall SetStep(int us, int ind_kart)
    { //  
      if (active[us])
        { //   
          if (wStep[us] == TU_STEP)
            { //   
              if (sizepodkid == 0 && UserKart(us, ind_kart))
                { //    
                  kTable[skTable] = ind_kart;
                  DeleteKartForUser(us, ind_kart);
                  skTable++;
                  sizepodkid++;
                  if (us == sUser - 1)
                    {
                      SetParamActive(0, 1);
                    }
                      else
                        {
                          SetParamActive(us + 1, 1);
                        }
                  return true;
                } // if (sizepodkid)
                  else
                    {
                      if (sizepodkid == 6)
                        {
                          return false;
                        }
                      if (GetOKPodkid(ind_kart) && UserKart(us, ind_kart))
                        {
                          kTable[skTable] = ind_kart;
                          DeleteKartForUser(us, ind_kart);
                          skTable++;
                          sizepodkid++;
                          if (us == sUser - 1)
                            {
                              SetParamActive(0, 1);
                            }
                              else
                                {
                                  SetParamActive(us + 1, 1);
                                }
                          return true;
                        }
                    }
            } // if (wStep == TU_STEP)
          if (wStep[us] == TU_PODKID)
            { //  
              if (sizepodkid < 6)
                { //   6  
                  if (GetOKPodkid(ind_kart) && UserKart(us, ind_kart))
                    {
                      kTable[skTable] = ind_kart;
                      DeleteKartForUser(us, ind_kart);
                      skTable++;
                      sizepodkid++;
                      if (us == 0)
                        {
                          SetParamActive(sUser - 1, 1);
                        }
                          else
                            {
                              SetParamActive(us - 1, 1);
                            }
                      return true;
                    }
                } // if (sizepodkid)
            } // if (wStep == TU_PODKID)
          if (wStep[us] == TU_OTBIV)
            { //  
              if (GetOtbilsia(ind_kart) && UserKart(us, ind_kart))
                {
                  kTable[skTable] = ind_kart;
                  DeleteKartForUser(us, ind_kart);
                  skTable++;
                  if (sUser == 2)
                    {
                      if (us == 0)
                        {
                          SetParamActive(1, 1);
                        }
                          else
                            {
                              SetParamActive(0, 1);
                            }
                    }
                      else
                        {
                          if ((us - 1) >= 0)
                            {
                              SetParamActive(us - 1, 2);
                            }
                              else
                                {
                                  SetParamActive(sUser - 1, 2);
                                }
                        }
                  if (skTable == 12)
                    { //    
                      SetNextStep(us);
                      ev(ALL_OTBIT);
                    }
                  return true;
                }
            }
        } // if (active)
      return false;
    };
  void __fastcall AddKart(ind_user)
    {
      if (skUser[ind_user] >= 6)
        {
          return;
        }
      int size;
      size = 6 - skUser[ind_user];
      for (int PrX = 0; PrX < size; PrX++)
        {
          if (sbKart > 0)
            {
              sbKart--;
              user[ind_user][skUser[ind_user]] = bKart[sbKart];
              skUser[ind_user]++;
            }
              else
                {
                  if (fl_kozer)
                    {
                      user[ind_user][skUser[ind_user]] = kozer;
                      skUser[ind_user]++;
                      fl_kozer = false;
                    }
                  return;
                }
        }
    };
  void __fastcall SetNextStep(int us)
    {
      sizepodkid = 0;
      SetParamwStep(us);
      SetParamActive(us, 1);
      //   
      for (int PrX = 0; PrX < skTable; PrX++)
        {
          sizeBito++;
          Bito[sizeBito - 1] = kTable[PrX];
        }
      skTable = 0;
      for (int PrX = 0; PrX < 12; PrX++)
        {
          kTable[PrX] = TK_NONE;
        }
      //   
      int ps;
      if ((us - 1) >= 0)
        {
          ps = us - 1;
        }
          else
            {
              ps = sUser - 1;
            }
      int size_for;
      if (sUser == 2)
        {
          size_for = 2;
        }
          else
            {
              size_for = 3;
            }
      for (int PrX = 0; PrX < size_for; PrX++)
        {
          AddKart(ps);
          ps++;
          if (ps == sUser)
            {
              ps = 0;
            }
        }
    };
  bool __fastcall SetNextStepA(void)
    {
      if (skTable == 0 || skTable == 1 || skTable == 3 || skTable == 5 || skTable == 7 ||
        skTable == 9 || skTable == 11)
          {
            return false;
          }
      for (int PrX = 0; PrX < sUser; PrX++)
        {
          if (wStep[PrX] == TU_OTBIV)
            {
              SetNextStep(PrX);
              return true;
            }
        }
      return false;
    };
  void __fastcall SetZabirau(void)
    {
      if (skTable == 0)
        {
          return;
        }
      sizepodkid = 0;
      int us;
      for (int PrX = 0; PrX < sUser; PrX++)
        {
          if (wStep[PrX] == TU_OTBIV)
            {
              us = PrX;
              break;
            }
        }
      for (int PrX = 0; PrX < skTable; PrX++)
        {
          user[us][skUser[us]] = kTable[PrX];
          skUser[us]++;
        }
      for (int PrX = 0; PrX < skTable; PrX++)
        {
          kTable[PrX] = TK_NONE;
        }
      skTable = 0;  
      //   
      int ps;
      if ((us - 1) >= 0)
        {
          ps = us - 1;
        }
          else
            {
              ps = sUser - 1;
            }
      int size_for;
      if (sUser == 2)
        {
          size_for = 2;
        }
          else
            {
              size_for = 3;
            }
      for (int PrX = 0; PrX < size_for; PrX++)
        {
          AddKart(ps);
          ps++;
          if (ps == sUser)
            {
              ps = 0;
            }
        }
      if ((us + 1) < sUser)
        {
          SetParamwStep(us + 1);
          SetParamActive(us + 1, 1);
        }
          else
            {
              SetParamwStep(0);
              SetParamActive(0, 1);
            }
    };
  int __fastcall GetKozer(void) { return kozer; }; //  
  int __fastcall GetKart(int us, int kr) { return user[us][kr]; }; //   
  int __fastcall GetSizeKartForUser(int us) { return skUser[us]; }; //     
  int __fastcall GetAllKartForBito(void) { return sbKart; }; //     
  int __fastcall GetKartBito(int index) { return bKart[index]; }; //    
  int __fastcall GetSizeTableKart(void) { return skTable; }; //     
  int __fastcall GetIntexKartForTable(int ind) { return kTable[ind]; }; //      
  bool __fastcall GetParamActive(int ind) { return active[ind]; }; //    
  int __fastcall GetParamwStep(int ind) { return wStep[ind]; }; //         
  int __fastcall GetSizeUsers(void) { return sUser; }; //   
  int __fastcall GetSizeBitoB(void) { return sizeBito; }; //     
  int __fastcall GetKartBitoB(int ind) { return Bito[ind]; }; //     
  bool __fastcall GetParamKozer(void) { return fl_kozer; }; //   
//  
  void __fastcall SetParamwStep(int notzero)
    { //     
      int ps;
      for (int PrX = 0; PrX < 6; PrX++)
        {
          if (PrX != notzero)
            {
              wStep[PrX] = TU_NONE;
            }
              else
                {
                  wStep[PrX] = TU_STEP;
                  ps = PrX;
                }
        }
      if (sUser == 2)
        {
          if (notzero == 0)
            {
              wStep[0] = TU_STEP;
              wStep[1] = TU_OTBIV;
            }
          if (notzero == 1)
            {
              wStep[0] = TU_OTBIV;
              wStep[1] = TU_STEP;
            }
          return;  
        }
      if (notzero == 5)
        {
          wStep[0] = TU_OTBIV;
          wStep[1] = TU_PODKID;
        }
          else
            {
              if (notzero == 4)
                {
                  wStep[5] = TU_OTBIV;
                  wStep[0] = TU_PODKID;
                }
                  else
                    {
                      wStep[notzero + 1] = TU_OTBIV;
                      wStep[notzero + 2] = TU_PODKID;
                    }
            }
    };
  void __fastcall SetParamActive(int ind, int param)
    {
      for (int PrX = 0; PrX < 6; PrX++)
        {
          active[PrX] = false;
        }
      if (param == 0)
        {
          return;
        }
      if (param == 1)
        {
          active[ind] = true;
        }
      if (param == 2)
        {
          active[ind] = true;
          if ((ind + 2) <= 5)
            {
              active[ind + 2] = true;
            }
              else
                {
                  active[(ind + 2) - 6] = true;
                }
        }
    };
  void __fastcall SetEvent(TEv *__ev)
    {
      ev = __ev;
    };
};
//---------------------------------------------------------------------------
#endif
